/*
	GuiHexKeySelectWindow.cpp
	Mattia Tristo
	2004
*/

#ifndef GUIHEXKEYAPP_H
#include "GuiHexKeyApp.h"
#endif

#ifndef GUIHEXKEYSELECTWINDOW_H
#include "GuiHexKeySelectWindow.h"
#endif

#ifndef GUIHEXKEYSELECTVIEW_H
#include "GuiHexKeySelectView.h"
#endif

#ifndef GUIHEXKEYINFOVIEW_H
#include "GuiHexKeyInfoView.h"
#endif

#ifndef GUIHEXKEYINFOWINDOW_H
#include "GuiHexKeyInfoWindow.h"
#endif

#ifndef GUIHEXKEYTABLESWINDOW_H
#include "GuiHexKeyTablesWindow.h"
#endif

HexKeySelectWindow::HexKeySelectWindow(BRect frame, int numKeymap, int numKey)
    : BWindow(frame, LABEL_SELECT_TITLE, B_TITLED_WINDOW_LOOK , B_MODAL_APP_WINDOW_FEEL, B_NOT_RESIZABLE | B_NOT_ZOOMABLE, B_CURRENT_WORKSPACE)
{
    HexKeySelectView  *aView;
	
    frame.OffsetTo(B_ORIGIN);
    aView = new HexKeySelectView(frame, "HexKeySelectView", numKeymap, numKey);
	aView->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
    AddChild(aView);
    
    Show();
}

void HexKeySelectWindow::MessageReceived(BMessage * msg)
{	
	switch(msg->what)
    {  
	  
	  case COMMAND_NEXT:
	  	{
	  		HexKeySelectView *aView;
    		aView = (HexKeySelectView *)FindView("HexKeySelectView");
    
	  		aView->NextPage();
	  		
		}
	  break;
	  
	  case COMMAND_PREV:
	  	{
	  		HexKeySelectView *aView;
    		aView = (HexKeySelectView *)FindView("HexKeySelectView");
    
	  		aView->PrevPage();
	  		
		}
	  break;
	  
	  case COMMAND_CANCEL:
	  	{
	  		Quit();
	  	}
	  break;
	  
	  case COMMAND_MODIFY:
	  	{
	  		HexKeySelectView *aView;
    		aView = (HexKeySelectView *)FindView("HexKeySelectView");
    		
    		if (aView->HasBeenSelected()) 
    		{
    			aView->ModifyRequested();
    			
    			BWindow *aWindow;
				int32    i = 0;
			
				while ((aWindow = be_app->WindowAt(i++)))
				{
					BString aString;
				
					aString.SetTo(aWindow->Title());
					
					if (!(aString.Compare(LABEL_KEYINFO_TITLE)))
					{
						aWindow->PostMessage(UPDATE_LABELS, aWindow);
					}
				}
    			
    			Quit();
	  			
	  		}
			
	  	}
	  break;
	  
	  case UPDATE_TABLE:
	  {
	  		HexKeySelectView *aView;
    		aView = (HexKeySelectView *)FindView("HexKeySelectView");
	  		
	  		int32 index;
	  		
	  		msg->FindInt32("Table", &index);
	  		
	  		aView->TableChanged((int)index);
	 		
	  }
	  break;
	  
	  case COMMAND_SELECT_TABLE:
	  	{
	  		HexKeyTablesWindow *aWindow;
	  		BRect 			 	aRect;
	  		
	  		aRect.Set(50, 50, 280, 400);
	  		aWindow = new HexKeyTablesWindow(aRect);
	  	}
	  break;
	  
	  default:
		BWindow::MessageReceived(msg);
	  break;
	
	}
	
}

bool HexKeySelectWindow::QuitRequested()
{
	return (true);
}
